"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { newObj[key] = obj[key]; } } } newObj.default = obj; return newObj; } }

var _chunkQP2A7HRUcjs = require('./chunk-QP2A7HRU.cjs');


var _chunkKEKBOJCFcjs = require('./chunk-KEKBOJCF.cjs');

// src/components/embed/v3/EmbeddedCheckoutV3IFrame.tsx
var _react = require('react');


var _clientsdkbase = require('@crossmint/client-sdk-base');
var _jsxruntime = require('react/jsx-runtime');
var CryptoWalletConnectionHandler = _react.lazy.call(void 0, 
  () => (
    // @ts-expect-error - Error because we dont use 'module' field in tsconfig, which is expected because we use tsup to compile
    Promise.resolve().then(() => _interopRequireWildcard(require("./components/embed/v3/crypto/CryptoWalletConnectionHandler.cjs"))).then((mod) => ({
      default: mod.CryptoWalletConnectionHandler
    }))
  )
);
function EmbeddedCheckoutV3IFrame(props) {
  const [iframeClient, setIframeClient] = _react.useState.call(void 0, null);
  const [height, setHeight] = _react.useState.call(void 0, 0);
  const { crossmint } = _chunkKEKBOJCFcjs.useCrossmint.call(void 0, );
  const apiClient = _chunkQP2A7HRUcjs.createCrossmintApiClient.call(void 0, crossmint, {
    usageOrigin: "client"
  });
  const embeddedCheckoutService = _clientsdkbase.crossmintEmbeddedCheckoutV3Service.call(void 0, { apiClient });
  const ref = _react.useRef.call(void 0, null);
  _react.useEffect.call(void 0, () => {
    const iframe = ref.current;
    if (!iframe || iframeClient) {
      return;
    }
    setIframeClient(embeddedCheckoutService.iframe.createClient(iframe));
  }, [ref.current, iframeClient]);
  _react.useEffect.call(void 0, () => {
    if (iframeClient == null) {
      return;
    }
    iframeClient.on("ui:height.changed", (data) => setHeight(data.height));
    return () => {
      iframeClient.off("ui:height.changed");
    };
  }, [iframeClient]);
  return /* @__PURE__ */ _jsxruntime.jsxs.call(void 0, _jsxruntime.Fragment, { children: [
    /* @__PURE__ */ _jsxruntime.jsx.call(void 0, 
      "iframe",
      {
        ref,
        src: embeddedCheckoutService.iframe.getUrl(props),
        id: "crossmint-embedded-checkout.iframe",
        role: "crossmint-embedded-checkout.iframe",
        allow: "payment *",
        style: {
          boxShadow: "none",
          border: "none",
          padding: "0px",
          width: "100%",
          minWidth: "100%",
          overflow: "hidden",
          display: "block",
          userSelect: "none",
          transform: "translate(0px)",
          opacity: "1",
          transition: "ease 0s, opacity 0.4s ease 0.1s",
          height: `${height}px`,
          backgroundColor: "transparent"
        }
      }
    ),
    props.payment.crypto.enabled ? /* @__PURE__ */ _jsxruntime.jsx.call(void 0, 
      CryptoWalletConnectionHandler,
      {
        iframeClient,
        apiKeyEnvironment: apiClient["parsedAPIKey"].environment
      }
    ) : null,
    /* @__PURE__ */ _jsxruntime.jsx.call(void 0, "span", { id: "crossmint-focus-target", tabIndex: -1 })
  ] });
}



exports.EmbeddedCheckoutV3IFrame = EmbeddedCheckoutV3IFrame;
//# sourceMappingURL=chunk-3DNABH3U.cjs.map