"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkLGY5FQOZcjs = require('./chunk-LGY5FQOZ.cjs');


var _chunkUQAKJ4T7cjs = require('./chunk-UQAKJ4T7.cjs');



var _chunk4S3T65XYcjs = require('./chunk-4S3T65XY.cjs');


var _chunk4DAZAO6Ycjs = require('./chunk-4DAZAO6Y.cjs');

// src/providers/auth/web3/DynamicWeb3WalletConnect.tsx
var _ethereum = require('@dynamic-labs/ethereum');
var _solana = require('@dynamic-labs/solana');
var _jsxruntime = require('react/jsx-runtime');
function DynamicWeb3WalletConnect({
  children,
  apiKeyEnvironment
}) {
  var _a, _b;
  const { crossmintAuth } = _chunk4S3T65XYcjs.useCrossmintAuth.call(void 0, );
  const { appearance } = _chunk4S3T65XYcjs.useAuthForm.call(void 0, );
  const cssOverrides = `.powered-by-dynamic { display: none !important; } .wallet-list__scroll-container { padding: 0px !important; } .wallet-list__search-container { padding-left: 0px !important; padding-right: 0px !important; } .dynamic-footer { display: none !important; } h1 { color: ${(_a = appearance == null ? void 0 : appearance.colors) == null ? void 0 : _a.textPrimary} !important; } * { color: ${(_b = appearance == null ? void 0 : appearance.colors) == null ? void 0 : _b.textSecondary} !important; }`;
  return /* @__PURE__ */ _jsxruntime.jsx.call(void 0, 
    _chunkUQAKJ4T7cjs.DynamicContextProviderWrapper,
    {
      apiKeyEnvironment,
      settings: {
        cssOverrides,
        walletConnectors: [_ethereum.EthereumWalletConnectors, _solana.SolanaWalletConnectors],
        events: {
          onAuthFlowCancel() {
            console.log("[CryptoWalletConnectionHandler] onAuthFlowCancel");
          },
          onAuthFlowClose() {
            console.log("[CryptoWalletConnectionHandler] onAuthFlowClose");
          },
          onAuthFailure(data, reason) {
            console.error("[CryptoWalletConnectionHandler] onAuthFailure", data, reason);
          },
          onAuthSuccess(data) {
            console.log("[CryptoWalletConnectionHandler] onAuthSuccess", data);
          }
        },
        handlers: {
          handleConnectedWallet: (wallet) => _chunk4DAZAO6Ycjs.__async.call(void 0, this, null, function* () {
            var _a2;
            console.log("[CryptoWalletConnectionHandler] handleConnectedWallet", wallet);
            const address = wallet.address;
            if (!address) {
              console.error("[CryptoWalletConnectionHandler] handleConnectedWallet: address is missing");
              return false;
            }
            const chain = yield _chunkLGY5FQOZcjs.dynamicChainToCrossmintChain.call(void 0, wallet);
            console.log({ chain });
            try {
              const res = yield crossmintAuth == null ? void 0 : crossmintAuth.signInWithSmartWallet(address);
              const signature = yield (_a2 = wallet.connector) == null ? void 0 : _a2.signMessage(res.challenge);
              const authResponse = yield crossmintAuth == null ? void 0 : crossmintAuth.authenticateSmartWallet(address, signature);
              const oneTimeSecret = authResponse.oneTimeSecret;
              yield crossmintAuth == null ? void 0 : crossmintAuth.handleRefreshAuthMaterial(oneTimeSecret);
            } catch (error) {
              console.error("[CryptoWalletConnectionHandler] Error authenticating wallet:", error);
              return false;
            }
            return true;
          })
        }
      },
      children
    }
  );
}



exports.DynamicWeb3WalletConnect = DynamicWeb3WalletConnect;
//# sourceMappingURL=chunk-6HYESP6N.cjs.map