import {
  __async,
  __spreadProps,
  __spreadValues
} from "./chunk-CRTRMMJ7.js";

// src/components/embed/v3/crypto/utils/handleSendTransaction.ts
function handleSendTransaction(primaryWallet, chain, serializedTransaction, iframeClient) {
  return __async(this, null, function* () {
    const commonParams = {
      chain,
      serializedTransaction,
      iframeClient
    };
    switch (primaryWallet.chain) {
      case "EVM":
        const { handleEvmTransaction } = yield import("./components/embed/v3/crypto/utils/handleEvmTransaction.js");
        return yield handleEvmTransaction(__spreadProps(__spreadValues({}, commonParams), { primaryWallet }));
      case "SOL":
        const { handleSolanaTransaction } = yield import("./components/embed/v3/crypto/utils/handleSolanaTransaction.js");
        return yield handleSolanaTransaction(__spreadProps(__spreadValues({}, commonParams), { primaryWallet }));
      default:
        throw new Error(`Connected wallet is on an unsupported chain: ${primaryWallet.chain}`);
    }
  });
}

export {
  handleSendTransaction
};
//# sourceMappingURL=chunk-A6Q4Z5TO.js.map