"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkAUCL5NPWcjs = require('../../../../chunk-AUCL5NPW.cjs');


var _chunkLGY5FQOZcjs = require('../../../../chunk-LGY5FQOZ.cjs');


var _chunkUQAKJ4T7cjs = require('../../../../chunk-UQAKJ4T7.cjs');



var _chunk4DAZAO6Ycjs = require('../../../../chunk-4DAZAO6Y.cjs');

// src/components/embed/v3/crypto/CryptoWalletConnectionHandler.tsx
var _ethereum = require('@dynamic-labs/ethereum');
var _sdkreactcore = require('@dynamic-labs/sdk-react-core');
var _solana = require('@dynamic-labs/solana');
var _react = require('react');
var _jsxruntime = require('react/jsx-runtime');
function CryptoWalletConnectionHandler(props) {
  const { iframeClient, apiKeyEnvironment } = props;
  return /* @__PURE__ */ _jsxruntime.jsx.call(void 0, 
    _chunkUQAKJ4T7cjs.DynamicContextProviderWrapper,
    {
      apiKeyEnvironment,
      settings: {
        walletConnectors: [_ethereum.EthereumWalletConnectors, _solana.SolanaWalletConnectors],
        events: {
          onAuthFlowCancel() {
            console.log("[CryptoWalletConnectionHandler] onAuthFlowCancel");
            iframeClient == null ? void 0 : iframeClient.send("crypto:connect-wallet.failed", {
              error: "cancelled"
            });
          },
          onAuthFlowClose() {
            console.log("[CryptoWalletConnectionHandler] onAuthFlowClose");
          },
          onAuthFailure(data, reason) {
            console.error("[CryptoWalletConnectionHandler] onAuthFailure", data, reason);
          },
          onAuthSuccess(data) {
            console.log("[CryptoWalletConnectionHandler] onAuthSuccess", data);
          }
        },
        handlers: {
          handleConnectedWallet: (wallet) => _chunk4DAZAO6Ycjs.__async.call(void 0, this, null, function* () {
            var _a;
            console.log("[CryptoWalletConnectionHandler] handleConnectedWallet", wallet);
            const address = wallet.address;
            if (!address) {
              console.error("[CryptoWalletConnectionHandler] handleConnectedWallet: address is missing");
              iframeClient == null ? void 0 : iframeClient.send("crypto:connect-wallet.failed", {
                error: "address is missing"
              });
              return false;
            }
            const chain = yield _chunkLGY5FQOZcjs.dynamicChainToCrossmintChain.call(void 0, wallet);
            iframeClient == null ? void 0 : iframeClient.send("crypto:connect-wallet.success", {
              address,
              chain,
              walletProviderKey: (_a = wallet.connector) == null ? void 0 : _a.key
            });
            return true;
          })
        }
      },
      children: /* @__PURE__ */ _jsxruntime.jsx.call(void 0, _CryptoWalletConnectionHandler, _chunk4DAZAO6Ycjs.__spreadValues.call(void 0, {}, props))
    }
  );
}
function _CryptoWalletConnectionHandler({ iframeClient }) {
  const [showDynamicModal, setShowDynamicModal] = _react.useState.call(void 0, false);
  const { primaryWallet } = _sdkreactcore.useDynamicContext.call(void 0, );
  _react.useEffect.call(void 0, () => {
    if (iframeClient == null) {
      return;
    }
    const showAuthFlowListener = iframeClient.on("crypto:connect-wallet.show", ({ show }) => {
      setShowDynamicModal(show);
    });
    return () => {
      iframeClient.off(showAuthFlowListener);
    };
  }, [iframeClient]);
  _react.useEffect.call(void 0, () => {
    if (iframeClient == null) {
      return;
    }
    const signTransactionListener = iframeClient.on(
      "crypto:send-transaction",
      (_0) => _chunk4DAZAO6Ycjs.__async.call(void 0, this, [_0], function* ({ chain, serializedTransaction }) {
        if (primaryWallet == null) {
          console.error("[CryptoWalletConnectionHandler] signTransaction: primaryWallet is missing");
          iframeClient.send("crypto:send-transaction:failed", {
            error: "primaryWallet is missing"
          });
          return;
        }
        yield _chunkAUCL5NPWcjs.handleSendTransaction.call(void 0, 
          primaryWallet,
          chain,
          serializedTransaction,
          iframeClient
        );
      })
    );
    return () => {
      iframeClient.off(signTransactionListener);
    };
  }, [iframeClient, primaryWallet]);
  return showDynamicModal ? /* @__PURE__ */ _jsxruntime.jsx.call(void 0, ShowDynamicModal, { setShowDynamicModal }) : null;
}
function ShowDynamicModal({ setShowDynamicModal }) {
  const context = _react.useContext.call(void 0, _sdkreactcore.DynamicContext);
  if (context == null) {
    throw new Error("DynamicContext is missing");
  }
  const { setShowAuthFlow, handleLogOut } = context;
  _react.useEffect.call(void 0, () => {
    var _a;
    (_a = document.getElementById("crossmint-focus-target")) == null ? void 0 : _a.focus();
    (() => _chunk4DAZAO6Ycjs.__async.call(void 0, this, null, function* () {
      yield handleLogOut();
      setShowAuthFlow(true, {
        clearErrors: true,
        emitCancelAuth: true,
        ignoreIfIsEmbeddedWidget: true,
        initializeWalletConnect: true,
        performMultiWalletChecks: false
        // Important to be false in order to not require double clicking connect button
      });
      setShowDynamicModal(false);
    }))();
  }, []);
  return null;
}



exports.CryptoWalletConnectionHandler = CryptoWalletConnectionHandler; exports.ShowDynamicModal = ShowDynamicModal;
//# sourceMappingURL=CryptoWalletConnectionHandler.cjs.map